commit 20eaf3c2031eaeb922e47ee0bf450644f47922ef
Author: Tim <tim@bastelfreak.de>
Date:   Wed Dec 15 20:40:51 2021 +0100

    modulesync 5.1.0

diff --git a/.gitlab-ci.yml b/.gitlab-ci.yml
deleted file mode 100644
index b53f49c..0000000
--- a/.gitlab-ci.yml
+++ /dev/null
@@ -1,40 +0,0 @@
----
-stages:
-  - syntax
-  - unit
-
-cache:
-  paths:
-    - vendor/bundle
-
-before_script:
-  - bundle -v
-  - rm Gemfile.lock || true
-  - "# Update system gems if requested. This is useful to temporarily workaround troubles in the test runner"
-  - "# Set `rubygems_version` in the .sync.yml to set a value"
-  - "# Ignore exit code of SIGPIPE'd yes to not fail with shell's pipefail set"
-  - '[ -z "$RUBYGEMS_VERSION" ] || (yes || true) | gem update --system $RUBYGEMS_VERSION'
-  - gem --version
-  - bundle -v
-  - bundle install --without system_tests --path vendor/bundle --jobs $(nproc)
-
-syntax lint metadata_lint check:symlinks check:git_ignore check:dot_underscore check:test_file rubocop-Ruby 2.5-Puppet ~> 6:
-  stage: syntax
-  image: registry.code.immerda.ch/immerda/container-images/ruby/devel:2.5
-  script:
-    - bundle exec rake syntax lint metadata_lint check:symlinks check:git_ignore check:dot_underscore check:test_file rubocop
-  variables:
-    PUPPET_GEM_VERSION: '~> 6'
-  tags:
-    - container
-
-parallel_spec-Ruby 2.5-Puppet ~> 6:
-  stage: unit
-  image: registry.code.immerda.ch/immerda/container-images/ruby/devel:2.5
-  script:
-    - bundle exec rake parallel_spec
-  variables:
-    PUPPET_GEM_VERSION: '~> 6'
-  tags:
-    - container
-
diff --git a/.msync.yml b/.msync.yml
index 43966c2..a83abd9 100644
--- a/.msync.yml
+++ b/.msync.yml
@@ -2,4 +2,4 @@
 # Managed by modulesync - DO NOT EDIT
 # https://voxpupuli.org/docs/updating-files-managed-with-modulesync/
 
-modulesync_config_version: '4.2.0'
+modulesync_config_version: '5.1.0'
diff --git a/.pdkignore b/.pdkignore
deleted file mode 100644
index e6215cd..0000000
--- a/.pdkignore
+++ /dev/null
@@ -1,42 +0,0 @@
-.git/
-.*.sw[op]
-.metadata
-.yardoc
-.yardwarns
-*.iml
-/.bundle/
-/.idea/
-/.vagrant/
-/coverage/
-/bin/
-/doc/
-/Gemfile.local
-/Gemfile.lock
-/junit/
-/log/
-/pkg/
-/spec/fixtures/manifests/
-/spec/fixtures/modules/
-/tmp/
-/vendor/
-/convert_report.txt
-/update_report.txt
-.DS_Store
-.project
-.envrc
-/inventory.yaml
-/appveyor.yml
-/.fixtures.yml
-/Gemfile
-/.gitattributes
-/.gitignore
-/.gitlab-ci.yml
-/.pdkignore
-/Rakefile
-/rakelib/
-/.rspec
-/.rubocop.yml
-/.travis.yml
-/.yardopts
-/spec/
-/.vscode/
diff --git a/.puppet-lint.rc b/.puppet-lint.rc
index cc96ece..dd8272c 100644
--- a/.puppet-lint.rc
+++ b/.puppet-lint.rc
@@ -1 +1,3 @@
---relative
+--fail-on-warnings
+--no-parameter_documentation-check
+--no-parameter_types-check
diff --git a/Gemfile b/Gemfile
index e43173e..113a361 100644
--- a/Gemfile
+++ b/Gemfile
@@ -4,7 +4,7 @@
 source ENV['GEM_SOURCE'] || "https://rubygems.org"
 
 group :test do
-  gem 'voxpupuli-test', '~> 2.5',   :require => false
+  gem 'voxpupuli-test', '~> 5.0',   :require => false
   gem 'coveralls',                  :require => false
   gem 'simplecov-console',          :require => false
   gem 'puppet_metadata', '~> 1.0',  :require => false
@@ -22,7 +22,7 @@ end
 
 group :release do
   gem 'github_changelog_generator', '>= 1.16.1',  :require => false if RUBY_VERSION >= '2.5'
-  gem 'voxpupuli-release', '>= 1.0.2',            :require => false
+  gem 'voxpupuli-release', '>= 1.2.0',            :require => false
   gem 'puppet-strings', '>= 2.2',                 :require => false
 end
 
diff --git a/Rakefile b/Rakefile
index 80b799d..f92f051 100644
--- a/Rakefile
+++ b/Rakefile
@@ -1,7 +1,7 @@
 # Managed by modulesync - DO NOT EDIT
 # https://voxpupuli.org/docs/updating-files-managed-with-modulesync/
 
-# Attempt to load voxupuli-test (which pulls in puppetlabs_spec_helper),
+# Attempt to load voxpupuli-test (which pulls in puppetlabs_spec_helper),
 # otherwise attempt to load it directly.
 begin
   require 'voxpupuli/test/rake'
diff --git a/appveyor.yml b/appveyor.yml
deleted file mode 100644
index ec38949..0000000
--- a/appveyor.yml
+++ /dev/null
@@ -1,56 +0,0 @@
----
-version: 1.1.x.{build}
-branches:
-  only:
-    - master
-    - release
-skip_commits:
-  message: /^\(?doc\)?.*/
-clone_depth: 10
-init:
-  - SET
-  - 'mkdir C:\ProgramData\PuppetLabs\code && exit 0'
-  - 'mkdir C:\ProgramData\PuppetLabs\facter && exit 0'
-  - 'mkdir C:\ProgramData\PuppetLabs\hiera && exit 0'
-  - 'mkdir C:\ProgramData\PuppetLabs\puppet\var && exit 0'
-environment:
-  matrix:
-    -
-      RUBY_VERSION: 24-x64
-      CHECK: syntax lint metadata_lint check:symlinks check:git_ignore check:dot_underscore check:test_file rubocop
-    -
-      PUPPET_GEM_VERSION: ~> 5.0
-      RUBY_VERSION: 24
-      CHECK: parallel_spec
-    -
-      PUPPET_GEM_VERSION: ~> 5.0
-      RUBY_VERSION: 24-x64
-      CHECK: parallel_spec
-    -
-      PUPPET_GEM_VERSION: ~> 6.0
-      RUBY_VERSION: 25
-      CHECK: parallel_spec
-    -
-      PUPPET_GEM_VERSION: ~> 6.0
-      RUBY_VERSION: 25-x64
-      CHECK: parallel_spec
-matrix:
-  fast_finish: true
-install:
-  - set PATH=C:\Ruby%RUBY_VERSION%\bin;%PATH%
-  - bundle install --jobs 4 --retry 2 --without system_tests
-  - type Gemfile.lock
-build: off
-test_script:
-  - bundle exec puppet -V
-  - ruby -v
-  - gem -v
-  - bundle -v
-  - bundle exec rake %CHECK%
-notifications:
-  - provider: Email
-    to:
-      - nobody@nowhere.com
-    on_build_success: false
-    on_build_failure: false
-    on_build_status_changed: false
diff --git a/spec/spec_helper.rb b/spec/spec_helper.rb
index 13da4ce..78e8b77 100644
--- a/spec/spec_helper.rb
+++ b/spec/spec_helper.rb
@@ -1,3 +1,5 @@
+# frozen_string_literal: true
+
 # Managed by modulesync - DO NOT EDIT
 # https://voxpupuli.org/docs/updating-files-managed-with-modulesync/
 
@@ -7,15 +9,13 @@ end
 
 # puppetlabs_spec_helper will set up coverage if the env variable is set.
 # We want to do this if lib exists and it hasn't been explicitly set.
-ENV['COVERAGE'] ||= 'yes' if Dir.exist?(File.expand_path('../../lib', __FILE__))
+ENV['COVERAGE'] ||= 'yes' if Dir.exist?(File.expand_path('../lib', __dir__))
 
 require 'voxpupuli/test/spec_helper'
 
 if File.exist?(File.join(__dir__, 'default_module_facts.yml'))
   facts = YAML.safe_load(File.read(File.join(__dir__, 'default_module_facts.yml')))
-  if facts
-    facts.each do |name, value|
-      add_custom_fact name.to_sym, value
-    end
+  facts&.each do |name, value|
+    add_custom_fact name.to_sym, value
   end
 end
diff --git a/spec/spec_helper_acceptance.rb b/spec/spec_helper_acceptance.rb
index d3b906b..d3a6e23 100644
--- a/spec/spec_helper_acceptance.rb
+++ b/spec/spec_helper_acceptance.rb
@@ -1,3 +1,5 @@
+# frozen_string_literal: true
+
 # Managed by modulesync - DO NOT EDIT
 # https://voxpupuli.org/docs/updating-files-managed-with-modulesync/
 