commit 65ed81ba2f490e8016946b7f4923bf9f276d808e
Author: Tim Meusel <tim@bastelfreak.de>
Date:   Tue Jul 9 16:14:57 2024 +0200

    partial modulesync 9.1.0
    
    This excludes the Gemfile changes

diff --git a/.github/CONTRIBUTING.md b/.github/CONTRIBUTING.md
index 8809327..daceb64 100644
--- a/.github/CONTRIBUTING.md
+++ b/.github/CONTRIBUTING.md
@@ -245,15 +245,23 @@ with:
 BEAKER_PUPPET_COLLECTION=puppet7 BEAKER_setfile=debian11-64 bundle exec rake beaker
 ```
 
+or
+
+```sh
+BEAKER_PUPPET_COLLECTION=none BEAKER_setfile=archlinux-64 bundle exec rake beaker
+```
+
+This latter example will use the distribution's own version of Puppet.
+
 You can replace the string `debian11` with any common operating system.
 The following strings are known to work:
 
 * ubuntu2004
 * ubuntu2204
 * debian11
-* centos7
-* centos8
+* debian12
 * centos9
+* archlinux
 * almalinux8
 * almalinux9
 * fedora36
diff --git a/.github/labeler.yml b/.github/labeler.yml
index 7899de8..f2d08d6 100644
--- a/.github/labeler.yml
+++ b/.github/labeler.yml
@@ -1,3 +1,6 @@
 ---
+# Managed by modulesync - DO NOT EDIT
+# https://voxpupuli.org/docs/updating-files-managed-with-modulesync/
+
 skip-changelog:
  - head-branch: ['^release-*', 'release']
diff --git a/.github/release.yml b/.github/release.yml
new file mode 100644
index 0000000..f5b5d7a
--- /dev/null
+++ b/.github/release.yml
@@ -0,0 +1,42 @@
+---
+# Managed by modulesync - DO NOT EDIT
+# https://voxpupuli.org/docs/updating-files-managed-with-modulesync/
+
+# https://docs.github.com/en/repositories/releasing-projects-on-github/automatically-generated-release-notes
+
+changelog:
+  exclude:
+    labels:
+      - duplicate
+      - invalid
+      - modulesync
+      - question
+      - skip-changelog
+      - wont-fix
+      - wontfix
+
+  categories:
+    - title: Breaking Changes 🛠
+      labels:
+        - backwards-incompatible
+
+    - title: New Features 🎉
+      labels:
+        - enhancement
+
+    - title: Bug Fixes 🐛
+      labels:
+        - bug
+
+    - title: Documentation Updates 📚
+      labels:
+        - documentation
+        - docs
+
+    - title: Dependency Updates ⬆️
+      labels:
+        - dependencies
+
+    - title: Other Changes
+      labels:
+        - "*"
diff --git a/.github/workflows/labeler.yml b/.github/workflows/labeler.yml
new file mode 100644
index 0000000..66127cd
--- /dev/null
+++ b/.github/workflows/labeler.yml
@@ -0,0 +1,17 @@
+---
+# Managed by modulesync - DO NOT EDIT
+# https://voxpupuli.org/docs/updating-files-managed-with-modulesync/
+
+name: "Pull Request Labeler"
+
+on:
+  pull_request_target: {}
+
+jobs:
+  labeler:
+    permissions:
+      contents: read
+      pull-requests: write
+    runs-on: ubuntu-latest
+    steps:
+    - uses: actions/labeler@v5
diff --git a/.github/workflows/release.yml b/.github/workflows/release.yml
index 55324aa..93b33c2 100644
--- a/.github/workflows/release.yml
+++ b/.github/workflows/release.yml
@@ -20,3 +20,10 @@ jobs:
       #  https://docs.github.com/en/actions/security-guides/encrypted-secrets
       username: ${{ secrets.PUPPET_FORGE_USERNAME }}
       api_key: ${{ secrets.PUPPET_FORGE_API_KEY }}
+
+  create-github-release:
+    name: Create GitHub Release
+    runs-on: ubuntu-latest
+    steps:
+      - name: Create GitHub release
+        uses: voxpupuli/gha-create-a-github-release@v1
diff --git a/.msync.yml b/.msync.yml
index 3607168..95e8c97 100644
--- a/.msync.yml
+++ b/.msync.yml
@@ -2,4 +2,4 @@
 # Managed by modulesync - DO NOT EDIT
 # https://voxpupuli.org/docs/updating-files-managed-with-modulesync/
 
-modulesync_config_version: '9.0.0'
+modulesync_config_version: '9.1.0'
diff --git a/.pmtignore b/.pmtignore
index 10b9830..a9d37aa 100644
--- a/.pmtignore
+++ b/.pmtignore
@@ -20,6 +20,7 @@
 /.github/
 /.librarian/
 /Puppetfile.lock
+/Puppetfile
 *.iml
 /.editorconfig
 /.fixtures.yml
diff --git a/.puppet-lint.rc b/.puppet-lint.rc
index 02a3e71..37817b6 100644
--- a/.puppet-lint.rc
+++ b/.puppet-lint.rc
@@ -1 +1,4 @@
+# Managed by modulesync - DO NOT EDIT
+# https://voxpupuli.org/docs/updating-files-managed-with-modulesync/
+
 --fail-on-warnings
diff --git a/spec/spec_helper.rb b/spec/spec_helper.rb
index b12ae2f..58c9b66 100644
--- a/spec/spec_helper.rb
+++ b/spec/spec_helper.rb
@@ -3,28 +3,22 @@
 # Managed by modulesync - DO NOT EDIT
 # https://voxpupuli.org/docs/updating-files-managed-with-modulesync/
 
-RSpec.configure do |c|
-  c.before do
-    # select the systemd service provider even when on docker
-    # https://tickets.puppetlabs.com/browse/PUP-11167
-    if defined?(facts) && %w[Archlinux RedHat].include?(facts[:os]['family'])
-      allow(Puppet::FileSystem).to receive(:exist?).and_call_original
-      allow(Puppet::FileSystem).to receive(:exist?).with('/proc/1/comm').and_return(true)
-      allow(Puppet::FileSystem).to receive(:read).and_call_original
-      allow(Puppet::FileSystem).to receive(:read).with('/proc/1/comm').and_return(['systemd'])
-    end
-  end
-end
-
 # puppetlabs_spec_helper will set up coverage if the env variable is set.
 # We want to do this if lib exists and it hasn't been explicitly set.
 ENV['COVERAGE'] ||= 'yes' if Dir.exist?(File.expand_path('../lib', __dir__))
 
 require 'voxpupuli/test/spec_helper'
 
+RSpec.configure do |c|
+  c.facterdb_string_keys = false
+end
+
+add_mocked_facts!
+
 if File.exist?(File.join(__dir__, 'default_module_facts.yml'))
   facts = YAML.safe_load(File.read(File.join(__dir__, 'default_module_facts.yml')))
   facts&.each do |name, value|
     add_custom_fact name.to_sym, value
   end
 end
+Dir['./spec/support/spec/**/*.rb'].sort.each { |f| require f }