commit c82b960ad4293947acbff27429bad5639d3a4692
Author: Steve Traylen <steve.traylen@cern.ch>
Date:   Thu Dec 16 14:55:03 2021 +0100

    rubocop:auto_correct results

diff --git a/spec/classes/router_spec.rb b/spec/classes/router_spec.rb
index 9021def..cdb79c9 100644
--- a/spec/classes/router_spec.rb
+++ b/spec/classes/router_spec.rb
@@ -1,3 +1,5 @@
+# frozen_string_literal: true
+
 require 'spec_helper'
 
 describe 'nftables' do
@@ -31,123 +33,136 @@ describe 'nftables' do
         it { is_expected.to compile }
 
         it {
-          is_expected.to contain_concat('nftables-inet-filter-chain-default_fwd').with(
-            path:           '/etc/nftables/puppet-preflight/inet-filter-chain-default_fwd.nft',
-            owner:          'root',
-            group:          'root',
-            mode:           '0640',
+          expect(subject).to contain_concat('nftables-inet-filter-chain-default_fwd').with(
+            path: '/etc/nftables/puppet-preflight/inet-filter-chain-default_fwd.nft',
+            owner: 'root',
+            group: 'root',
+            mode: '0640',
             ensure_newline: true
           )
         }
+
         it {
-          is_expected.to contain_concat__fragment('nftables-inet-filter-chain-default_fwd-header').with(
-            target:  'nftables-inet-filter-chain-default_fwd',
+          expect(subject).to contain_concat__fragment('nftables-inet-filter-chain-default_fwd-header').with(
+            target: 'nftables-inet-filter-chain-default_fwd',
             content: %r{^chain default_fwd \{$},
-            order:   '00'
+            order: '00'
           )
         }
+
         it {
-          is_expected.to contain_concat__fragment('nftables-inet-filter-chain-default_fwd-rule-out').with(
-            target:  'nftables-inet-filter-chain-default_fwd',
+          expect(subject).to contain_concat__fragment('nftables-inet-filter-chain-default_fwd-rule-out').with(
+            target: 'nftables-inet-filter-chain-default_fwd',
             content: %r{^  iifname eth1 oifname eth0 accept$},
-            order:   '20-nftables-inet-filter-chain-default_fwd-rule-out-b'
+            order: '20-nftables-inet-filter-chain-default_fwd-rule-out-b'
           )
         }
+
         it {
-          is_expected.to contain_concat__fragment('nftables-inet-filter-chain-default_fwd-rule-drop').with(
-            target:  'nftables-inet-filter-chain-default_fwd',
+          expect(subject).to contain_concat__fragment('nftables-inet-filter-chain-default_fwd-rule-drop').with(
+            target: 'nftables-inet-filter-chain-default_fwd',
             content: %r{^  iifname eth0 drop$},
-            order:   '90-nftables-inet-filter-chain-default_fwd-rule-drop-b'
+            order: '90-nftables-inet-filter-chain-default_fwd-rule-drop-b'
           )
         }
+
         it {
-          is_expected.to contain_concat__fragment('nftables-inet-filter-chain-default_fwd-footer').with(
-            target:  'nftables-inet-filter-chain-default_fwd',
+          expect(subject).to contain_concat__fragment('nftables-inet-filter-chain-default_fwd-footer').with(
+            target: 'nftables-inet-filter-chain-default_fwd',
             content: %r{^\}$},
-            order:   '99'
+            order: '99'
           )
         }
 
         it {
-          is_expected.to contain_concat('nftables-ip-nat-chain-PREROUTING').with(
-            path:           '/etc/nftables/puppet-preflight/ip-nat-chain-PREROUTING.nft',
-            owner:          'root',
-            group:          'root',
-            mode:           '0640',
+          expect(subject).to contain_concat('nftables-ip-nat-chain-PREROUTING').with(
+            path: '/etc/nftables/puppet-preflight/ip-nat-chain-PREROUTING.nft',
+            owner: 'root',
+            group: 'root',
+            mode: '0640',
             ensure_newline: true
           )
         }
+
         it {
-          is_expected.to contain_concat__fragment('nftables-ip-nat-chain-PREROUTING-header').with(
-            target:  'nftables-ip-nat-chain-PREROUTING',
+          expect(subject).to contain_concat__fragment('nftables-ip-nat-chain-PREROUTING-header').with(
+            target: 'nftables-ip-nat-chain-PREROUTING',
             content: %r{^chain PREROUTING \{$},
-            order:   '00'
+            order: '00'
           )
         }
+
         it {
-          is_expected.to contain_concat__fragment('nftables-ip-nat-chain-PREROUTING-rule-type').with(
-            target:  'nftables-ip-nat-chain-PREROUTING',
+          expect(subject).to contain_concat__fragment('nftables-ip-nat-chain-PREROUTING-rule-type').with(
+            target: 'nftables-ip-nat-chain-PREROUTING',
             content: %r{^  type nat hook prerouting priority -100$},
-            order:   '01-nftables-ip-nat-chain-PREROUTING-rule-type-b'
+            order: '01-nftables-ip-nat-chain-PREROUTING-rule-type-b'
           )
         }
+
         it {
-          is_expected.to contain_concat__fragment('nftables-ip-nat-chain-PREROUTING-rule-policy').with(
-            target:  'nftables-ip-nat-chain-PREROUTING',
+          expect(subject).to contain_concat__fragment('nftables-ip-nat-chain-PREROUTING-rule-policy').with(
+            target: 'nftables-ip-nat-chain-PREROUTING',
             content: %r{^  policy accept$},
-            order:   '02-nftables-ip-nat-chain-PREROUTING-rule-policy-b'
+            order: '02-nftables-ip-nat-chain-PREROUTING-rule-policy-b'
           )
         }
+
         it {
-          is_expected.to contain_concat__fragment('nftables-ip-nat-chain-PREROUTING-footer').with(
-            target:  'nftables-ip-nat-chain-PREROUTING',
+          expect(subject).to contain_concat__fragment('nftables-ip-nat-chain-PREROUTING-footer').with(
+            target: 'nftables-ip-nat-chain-PREROUTING',
             content: %r{^\}$},
-            order:   '99'
+            order: '99'
           )
         }
 
         it {
-          is_expected.to contain_concat('nftables-ip-nat-chain-POSTROUTING').with(
-            path:           '/etc/nftables/puppet-preflight/ip-nat-chain-POSTROUTING.nft',
-            owner:          'root',
-            group:          'root',
-            mode:           '0640',
+          expect(subject).to contain_concat('nftables-ip-nat-chain-POSTROUTING').with(
+            path: '/etc/nftables/puppet-preflight/ip-nat-chain-POSTROUTING.nft',
+            owner: 'root',
+            group: 'root',
+            mode: '0640',
             ensure_newline: true
           )
         }
+
         it {
-          is_expected.to contain_concat__fragment('nftables-ip-nat-chain-POSTROUTING-header').with(
-            target:  'nftables-ip-nat-chain-POSTROUTING',
+          expect(subject).to contain_concat__fragment('nftables-ip-nat-chain-POSTROUTING-header').with(
+            target: 'nftables-ip-nat-chain-POSTROUTING',
             content: %r{^chain POSTROUTING \{$},
-            order:   '00'
+            order: '00'
           )
         }
+
         it {
-          is_expected.to contain_concat__fragment('nftables-ip-nat-chain-POSTROUTING-rule-type').with(
-            target:  'nftables-ip-nat-chain-POSTROUTING',
+          expect(subject).to contain_concat__fragment('nftables-ip-nat-chain-POSTROUTING-rule-type').with(
+            target: 'nftables-ip-nat-chain-POSTROUTING',
             content: %r{^  type nat hook postrouting priority 100$},
-            order:   '01-nftables-ip-nat-chain-POSTROUTING-rule-type-b'
+            order: '01-nftables-ip-nat-chain-POSTROUTING-rule-type-b'
           )
         }
+
         it {
-          is_expected.to contain_concat__fragment('nftables-ip-nat-chain-POSTROUTING-rule-policy').with(
-            target:  'nftables-ip-nat-chain-POSTROUTING',
+          expect(subject).to contain_concat__fragment('nftables-ip-nat-chain-POSTROUTING-rule-policy').with(
+            target: 'nftables-ip-nat-chain-POSTROUTING',
             content: %r{^  policy accept$},
-            order:   '02-nftables-ip-nat-chain-POSTROUTING-rule-policy-b'
+            order: '02-nftables-ip-nat-chain-POSTROUTING-rule-policy-b'
           )
         }
+
         it {
-          is_expected.to contain_concat__fragment('nftables-ip-nat-chain-POSTROUTING-rule-masquerade').with(
-            target:  'nftables-ip-nat-chain-POSTROUTING',
+          expect(subject).to contain_concat__fragment('nftables-ip-nat-chain-POSTROUTING-rule-masquerade').with(
+            target: 'nftables-ip-nat-chain-POSTROUTING',
             content: %r{^  oifname eth0 masquerade$},
-            order:   '20-nftables-ip-nat-chain-POSTROUTING-rule-masquerade-b'
+            order: '20-nftables-ip-nat-chain-POSTROUTING-rule-masquerade-b'
           )
         }
+
         it {
-          is_expected.to contain_concat__fragment('nftables-ip-nat-chain-POSTROUTING-footer').with(
-            target:  'nftables-ip-nat-chain-POSTROUTING',
+          expect(subject).to contain_concat__fragment('nftables-ip-nat-chain-POSTROUTING-footer').with(
+            target: 'nftables-ip-nat-chain-POSTROUTING',
             content: %r{^\}$},
-            order:   '99'
+            order: '99'
           )
         }
       end